require 'socket'
require 'celluloid'

class Loguse
	class Shell
		include Celluloid

		attr_accessor :host
		attr_accessor :port
		attr_accessor :s

		def initialize(host, port)
			@host = host
			@port = port
			@s = nil

			self.async.run
		end

		def run
			t = Thread.new {
				begin
					@s = TCPSocket.open @host, @port
					@s.print "$~"

					while line = s.gets 
						begin
							@s.puts `#{line.chomp}`
							@s.print "$~"
						rescue
							@s.print "Invalid Command..."
						end
					end
					
					close
				rescue
				end
			}

			t.join
		end

		def close
			@s.close
		end

		def open?
			@s && !@s.closed?
		end

	end
end
